unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComObj, Spin, ExtDlgs;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    ListBox1: TListBox;
    Label3: TLabel;
    Button4: TButton;
    SpinButton1: TSpinButton;
    SpinButton2: TSpinButton;
    Label2: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
var
  E:variant;
  Callout:Variant;
{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
//  Excel   
begin
  E:=CreateOleObject('Excel.Application');
  E.Visible:=True;
end;

procedure TForm1.Button2Click(Sender: TObject);
//  
begin
  E.WorkBooks.Add;
end;


procedure TForm1.Button3Click(Sender: TObject);
// 
const msoCalloutThree=3;
var
  left,top:Extended;
begin
  left:=10;
  top:=11;
  if E.ActiveWorkBook.ActiveSheet.Shapes.Count>0 then
  begin
   left:=E.ActiveWorkBook.ActiveSheet.Shapes.
      item(E.ActiveWorkBook.ActiveSheet.Shapes.count).Left+20;
   top:=E.ActiveWorkBook.ActiveSheet.Shapes.
      item(E.ActiveWorkBook.ActiveSheet.Shapes.count).Top+20;
  end;
  E.ActiveWorkBook.ActiveSheet.Shapes.AddCallout(msoCalloutThree,
     left, top, 150, 100);
end;

procedure TForm1.Button4Click(Sender: TObject);
//  
var
  a: Integer;
begin
  ListBox1.Items.Clear;
  for a:=1 to E.ActiveWorkBook.ActiveSheet.Shapes.Count do
    ListBox1.Items.Add(E.ActiveWorkBook.ActiveSheet.Shapes.Item(a).Name);
end;

procedure TForm1.ListBox1Click(Sender: TObject);
//     ListBoxl,   ,
//     Shapes      
//  Callout.
begin
  Callout:=E.ActiveWorkBook.ActiveSheet.Shapes.Item(
    ListBox1.Items.Strings[ListBox1.ItemIndex]);
end;

procedure TForm1.Memo1Change(Sender: TObject);
//   
begin
  Callout.TextFrame.Characters.Text:=Memo1.Text;
end;

//  
procedure TForm1.SpinButton1DownClick(Sender: TObject);
begin
  Callout.Adjustments.item(1):=Callout.Adjustments.item[1]-0.01;
end;

procedure TForm1.SpinButton1UpClick(Sender: TObject);
begin
  Callout.Adjustments.item(1):=Callout.Adjustments.item[1]+0.01;
end;

//  
procedure TForm1.SpinButton2DownClick(Sender: TObject);
begin
  Callout.Adjustments.item(2):=Callout.Adjustments.item[2]-0.01;
end;

procedure TForm1.SpinButton2UpClick(Sender: TObject);
begin
  Callout.Adjustments.item(2):=Callout.Adjustments.item[2]+0.01;
end;

end.
